#! /bin/sh

#-----------------------------------------------------------------------
# 
Home=$(pwd)

#-----------------------------------------------------------------------
# $1=Name, $2=Version, 
Prepare()
{
	#Prepare configure
	libtoolize --force
	aclocal
	automake -a
	autoconf
}

#-----------------------------------------------------------------------
# $1=Package name, $2=part name
Project_Copy()
{
    mkdir -p MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2
    cp ../../$1/Project/GNU/$2/aclocal.m4 MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/autogen MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/config.guess MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/config.sub MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/configure MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/configure.ac MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/depcomp MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/install-sh MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/ltmain.sh MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/Makefile.am MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/Makefile.in MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
    cp ../../$1/Project/GNU/$2/missing MediaInfo_CLI_GNU_FromSource/$1/Project/GNU/$2/
}

#-----------------------------------------------------------------------
# Clean up
test -e MediaInfo_CLI_GNU_FromSource.tar     && rm    MediaInfo_CLI_GNU_FromSource.tar
test -e MediaInfo_CLI_GNU_FromSource.tar.bz2 && rm    MediaInfo_CLI_GNU_FromSource.tar.bz2
test -d MediaInfo_CLI_GNU_FromSource         && rm -r MediaInfo_CLI_GNU_FromSource
mkdir MediaInfo_CLI_GNU_FromSource

#-----------------------------------------------------------------------
# Copying : Licence files
cp ../Licence.html MediaInfo_CLI_GNU_FromSource/

#-----------------------------------------------------------------------
# Copying : History
cp ../History.CLI.txt MediaInfo_CLI_GNU_FromSource/

#-----------------------------------------------------------------------
# Copying : Information file
cp Readme.Linux.txt MediaInfo_CLI_GNU_FromSource/

#-----------------------------------------------------------------------
# Preparation
cd ../../ZenLib/Project/GNU/Library
Prepare ZenLib 0
cd $Home
cd ../../MediaInfoLib/Project/GNU/Library
Prepare LibMediaInfoLib 0
cd $Home
cd ../../MediaInfo/Project/GNU/CLI
Prepare MediaInfo 0
cd $Home

#-----------------------------------------------------------------------
# Global
cp ../../MediaInfo/Project/GNU/CLI/AddThisToRoot_CLI_compile.sh MediaInfo_CLI_GNU_FromSource/CLI_Compile.sh
chmod u+x MediaInfo_CLI_GNU_FromSource/CLI_Compile.sh

#-----------------------------------------------------------------------
# Shared
mkdir -p MediaInfo_CLI_GNU_FromSource/Shared/Project
cp -r ../../Shared/Project/_Common MediaInfo_CLI_GNU_FromSource/Shared/Project/
cp -r ../../Shared/Project/Ebml MediaInfo_CLI_GNU_FromSource/Shared/Project/
cp -r ../../Shared/Project/Matroska MediaInfo_CLI_GNU_FromSource/Shared/Project/
cp -r ../../Shared/Project/WxWidgets MediaInfo_CLI_GNU_FromSource/Shared/Project/
cp -r ../../Shared/Project/ZLib MediaInfo_CLI_GNU_FromSource/Shared/Project/

#-----------------------------------------------------------------------
# ZenLib
mkdir -p MediaInfo_CLI_GNU_FromSource/ZenLib/
cp ../../ZenLib/Licence.* MediaInfo_CLI_GNU_FromSource/ZenLib/
cp ../../ZenLib/History.* MediaInfo_CLI_GNU_FromSource/ZenLib/
Project_Copy ZenLib Library
cp ../../ZenLib/Project/GNU/Library/ZenLib-config.in MediaInfo_CLI_GNU_FromSource/ZenLib/Project/GNU/Library/
cp ../../ZenLib/Project/GNU/Library/wxwin.m4 MediaInfo_CLI_GNU_FromSource/ZenLib/Project/GNU/Library/
mkdir -p MediaInfo_CLI_GNU_FromSource/ZenLib/Source/ZenLib
cp -r ../../ZenLib/Source/ZenLib/* MediaInfo_CLI_GNU_FromSource/ZenLib/Source/ZenLib/

#-----------------------------------------------------------------------
# MediaInfoLib
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfoLib/
cp ../../MediaInfoLib/Licence.* MediaInfo_CLI_GNU_FromSource/MediaInfoLib/
cp ../../MediaInfoLib/History.* MediaInfo_CLI_GNU_FromSource/MediaInfoLib/
Project_Copy MediaInfoLib Library
cp ../../MediaInfoLib/Project/GNU/Library/MediaInfoLib-config.in MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Project/GNU/Library/
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Source/MediaInfo
cp -r ../../MediaInfoLib/Source/MediaInfo/* MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Source/MediaInfo/
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Source/MediaInfoDLL
cp -r ../../MediaInfoLib/Source/MediaInfoDLL/*.cpp MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Source/MediaInfoDLL/
cp -r ../../MediaInfoLib/Source/MediaInfoDLL/*.h MediaInfo_CLI_GNU_FromSource/MediaInfoLib/Source/MediaInfoDLL/

#-----------------------------------------------------------------------
# MediaInfo
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfo/
cp ../../MediaInfo/Licence.* MediaInfo_CLI_GNU_FromSource/MediaInfo/
cp ../../MediaInfo/History.CLI.* MediaInfo_CLI_GNU_FromSource/MediaInfo/
Project_Copy MediaInfo CLI
cp ../../MediaInfo/Project/GNU/CLI/wxwin.m4 MediaInfo_CLI_GNU_FromSource/MediaInfo/Project/GNU/CLI/
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfo/Source/CLI
cp -r ../../MediaInfo/Source/CLI/* MediaInfo_CLI_GNU_FromSource/MediaInfo/Source/CLI/
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfo/Source/Common
cp -r ../../MediaInfo/Source/Common/* MediaInfo_CLI_GNU_FromSource/MediaInfo/Source/Common/
mkdir -p MediaInfo_CLI_GNU_FromSource/MediaInfo/Release
cp -r ../../MediaInfo/Release/Readme.Linux.txt MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Readme.Mac.txt MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Readme.Windows.txt MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Release_CLI_GNU.sh MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Release_CLI_GNU_FromSource.sh MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Release_CLI_Mac_Intel.sh MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Release_CLI_Linux_i386.sh MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
cp -r ../../MediaInfo/Release/Release_CLI_Linux_x64.sh MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/
chmod u+x MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/Release_CLI_GNU.sh
chmod u+x MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/Release_CLI_GNU_FromSource.sh
chmod u+x MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/Release_CLI_Mac_Intel.sh
chmod u+x MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/Release_CLI_Linux_i386.sh
chmod u+x MediaInfo_CLI_GNU_FromSource/MediaInfo/Release/Release_CLI_Linux_x64.sh

#-----------------------------------------------------------------------
# Compressing Archive
tar jchf MediaInfo_CLI_GNU_FromSource.tar.bz2 MediaInfo_CLI_GNU_FromSource/*
